Class | Sequel::Postgres::Dataset
In: | lib/sequel/adapters/postgres.rb
Parent: | Sequel::Dataset

Dataset class for PostgreSQL datasets that use the pg, postgres, or postgres-pr driver.

### Methods

call fetch_rows prepare prepared_arg_placeholder use_cursor

### Included Modules

Sequel::Postgres::DatasetMethods

### Classes and Modules

Module Sequel::Postgres::Dataset::ArgumentMapper
Module Sequel::Postgres::Dataset::BindArgumentMethods
Module Sequel::Postgres::Dataset::PreparedStatementMethods

### Constants

PREPARED_ARG_PLACEHOLDER | = | LiteralString.new('$').freeze

### Public Instance methods

call(type, bind_vars={}, *values, &block)

Execute the given type of statement with the hash of values.

[Source]

         # File lib/sequel/adapters/postgres.rb, line 416
    416:         def call(type, bind_vars={}, *values, &block)
    417:           ps = to_prepared_statement(type, values)
    418:           ps.extend(BindArgumentMethods)
    419:           ps.call(bind_vars, &block)
    420:         end

fetch_rows(sql, &block)

Yield all rows returned by executing the given SQL and converting the types.

[Source]

         # File lib/sequel/adapters/postgres.rb, line 308
    308:       def fetch_rows(sql, &block)
    309:         return cursor_fetch_rows(sql, &block) if @opts[:cursor]
    310:         execute(sql){|res| yield_hash_rows(res, fetch_rows_set_cols(res), &block)}
    311:       end

prepare(type, name=nil, *values)

Prepare the given type of statement with the given name, and store it in the database to be called later.

[Source]

         # File lib/sequel/adapters/postgres.rb, line 424
    424:         def prepare(type, name=nil, *values)
    425:           ps = to_prepared_statement(type, values)
    426:           ps.extend(PreparedStatementMethods)
    427:           if name
    428:             ps.prepared_statement_name = name
    429:             db.prepared_statements[name] = ps
    430:           end
    431:           ps
    432:         end

prepared_arg_placeholder()

PostgreSQL uses $N for placeholders instead of ?, so use a $ as the placeholder.

[Source]

         # File lib/sequel/adapters/postgres.rb, line 438
    438:         def prepared_arg_placeholder
    439:           PREPARED_ARG_PLACEHOLDER
    440:         end

use_cursor(opts={})

Uses a cursor for fetching records, instead of fetching the entire result set at once. Can be used to process large datasets without holding all rows in memory (which is what the underlying drivers do by default). Options:

- :rows_per_fetch - the number of rows per fetch (default 1000). Higher numbers result in fewer queries but greater memory use.

Usage:

      DB[:huge_table].use_cursor.each{|row| p row}
      DB[:huge_table].use_cursor(:rows_per_fetch=>10000).each{|row| p row}

This is untested with the prepared statement/bound variable support, and unlikely to work with either.

[Source]

         # File lib/sequel/adapters/postgres.rb, line 328
    328:       def use_cursor(opts={})
    329:         clone(:cursor=>{:rows_per_fetch=>1000}.merge(opts))
    330:       end

[Validate]